Bug 1071434 (CVE-2014-2237)

Summary: CVE-2014-2237 openstack-keystone: trustee token revocation does not work with memcache backend
Product: [Other] Security Response Reporter: Vincent Danen <vdanen>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: aortega, apevec, apevec, ayoung, bfilippov, chrisw, dallan, d.busby, djorm, gkotton, gmollett, iheim, itamar, Jan.van.Eldik, jonathansteffan, jose.castro.leon, jrusnack, lhh, markmc, p, rbryant, rhos-maint, sclewis, yeylon
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20131211,reported=20140228,source=oss-security,cvss2=4.0/AV:N/AC:L/Au:S/C:N/I:P/A:N,fedora-all/openstack-keystone=affected,epel-6/openstack-keystone=affected,openstack-3/openstack-keystone=affected,openstack-4/openstack-keystone=affected,openstack-rdo/openstack-keystone=affected,cwe=CWE-613
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-05-29 19:30:33 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 1071493, 1071494, 1082418, 1085548    
Bug Blocks: 1039165, 1071436    

Description Vincent Danen 2014-02-28 14:17:47 EST
Title: Trustee token revocation does not work with memcache backend
Reporter: Morgan Fainberg (Metacloud)
Products: Keystone
Versions: 2013.1 up to 2013.1.4 and 2013.2 versions up to 2013.2.2

Description:
Morgan Fainberg from Metacloud reported a vulnerability in the Keystone
memcache token backend. When a trustor issues a trust token with
impersonation enabled, the token is only added to the trustor's token
list and not to the trustee's token list. This results in the trust
token not being invalidated by the trustee's token revocation (bulk
revocation). This is most noticeable when the trustee user is disabled
or the trustee changes a password. Only setups using the memcache
backend for tokens in Keystone are affected.


CVE request:

http://seclists.org/oss-sec/2014/q1/455

Upstream References:

https://bugs.launchpad.net/keystone/+bug/1260080
https://git.openstack.org/cgit/openstack/keystone/commit/?id=813d1254eb4f7a7d40009b23bbadbc4c5cc5daac
Comment 1 Vincent Danen 2014-02-28 15:47:04 EST
This was assigned CVE-2014-2237:

http://seclists.org/oss-sec/2014/q1/463
Comment 3 Kurt Seifried 2014-02-28 18:21:40 EST
Created openstack-keystone tracking bugs for this issue:

Affects: fedora-all [bug 1071493]
Comment 4 Kurt Seifried 2014-03-04 15:51:29 EST
Official fixes have been released:

Icehouse (development branch) fix:
https://review.openstack.org/60743

Havana fix:
https://review.openstack.org/75521

Grizzly fix:
https://review.openstack.org/75526

Notes:
This fix will be included in the icehouse-3 development milestone and in
future 2013.1.5 and 2013.2.3 releases.
Comment 6 errata-xmlrpc 2014-04-03 16:19:00 EDT
This issue has been addressed in following products:

  OpenStack 3 for RHEL 6

Via RHSA-2014:0368 https://rhn.redhat.com/errata/RHSA-2014-0368.html
Comment 7 Fedora Update System 2014-04-05 00:54:43 EDT
openstack-keystone-2013.1.5-2.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2014-04-17 02:00:46 EDT
openstack-keystone-2013.2.3-2.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 errata-xmlrpc 2014-05-29 16:34:03 EDT
This issue has been addressed in following products:

  OpenStack 4 for RHEL 6

Via RHSA-2014:0580 https://rhn.redhat.com/errata/RHSA-2014-0580.html